<%@ Page Language="VB" %>

<%------------------------------------------------------------------------------------------
By: Mustafa Basgun (http://www.basgun.com)
Last Updated Date: 12/05/2007
AjaxControlToolkit.dll in the current BIN directory has the version of: 1.0.10920.0
This VB.NET version of Web Site File Manager applies the terms in the following link:
http://www.binaryintellect.net/legal.aspx
Original document (C# version) by BinaryIntellect.net is available to download at:
http://www.binaryintellect.net/articles/44b73e89-78d9-4ad7-8157-bce54ad31fde.aspx
------------------------------------------------------------------------------------------%>

<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>
<%@ Import Namespace = "System.IO" %>
<%@ Import Namespace = "System.Web.Services" %>
<%@ Import Namespace = "System.Web.Script.Services" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script language="javascript" type="text/javascript">
    
    var FileManager;
    
    function pageLoad()
    {
        FileManager=new BinaryIntellect.Web.UI.FileManager();
        
        var obj=document.getElementById('Panel5');
        obj.style.visibility="hidden";
        
        var obj=document.getElementById('Panel6');
        obj.style.visibility="hidden";
    }
    
</script>

<script runat="server">

    Public Class FileSystemItem
        
        Private strName As String
        Private strFullName As String
        Private dtCreationDate As DateTime
        Private dtLastAccessDate As DateTime
        Private dtLastWriteDate As DateTime
        Private blnIsFolder As Boolean
        Private lngSize As Long
        Private lngFileCount As Long
        Private lngSubFolderCount As Long
    
        Public Property Name() As String
            Get
                Return strName
            End Get
            Set(ByVal value As String)
                strName = value
            End Set
        End Property
    
        Public Property FullName() As String
            Get
                Return strFullName
            End Get
            Set(ByVal value As String)
                strFullName = value
            End Set
        End Property
    
        Public Property CreationDate() As DateTime
            Get
                Return dtCreationDate
            End Get
            Set(ByVal value As DateTime)
                dtCreationDate = value
            End Set
        End Property
    
        Public Property IsFolder() As Boolean
            Get
                Return blnIsFolder
            End Get
            Set(ByVal value As Boolean)
                blnIsFolder = value
            End Set
        End Property
    
        Public Property Size() As Long
            Get
                Return lngSize
            End Get
            Set(ByVal value As Long)
                lngSize = value
            End Set
        End Property
    
        Public Property LastAccessDate() As DateTime
            Get
                Return dtLastAccessDate
            End Get
            Set(ByVal value As DateTime)
                dtLastAccessDate = value
            End Set
        End Property
    
        Public Property LastWriteDate() As DateTime
            Get
                Return dtLastWriteDate
            End Get
            Set(ByVal value As DateTime)
                dtLastWriteDate = value
            End Set
        End Property
    
        Public Property FileCount() As Long
            Get
                Return lngFileCount
            End Get
            Set(ByVal value As Long)
                lngFileCount = value
            End Set
        End Property
    
        Public Property SubFolderCount() As Long
            Get
                Return lngSubFolderCount
            End Get
            Set(ByVal value As Long)
                lngSubFolderCount = value
            End Set
        End Property
        
    End Class

    Public Class FileSystemManager
        
        Private Shared strRootFolder As String
    
        Shared Sub New()
            strRootFolder = HttpContext.Current.Request.PhysicalApplicationPath
            strRootFolder = strRootFolder.Substring(0, strRootFolder.LastIndexOf("\"))
        End Sub
    
        Public Shared Function GetRootPath() As String
            Return strRootFolder
        End Function
    
        Public Shared Sub SetRootPath(ByVal path As String)
            strRootFolder = path
        End Sub
    
        Public Shared Function GetItems() As List(Of FileSystemItem)
            Return GetItems(strRootFolder)
        End Function
    
        Public Shared Function GetItems(ByVal path As String) As List(Of FileSystemItem)
            
            Dim folders As String() = Directory.GetDirectories(path)
            Dim files As String() = Directory.GetFiles(path)
            Dim list As New List(Of FileSystemItem)()
            
            For Each s As String In folders
                Dim item As New FileSystemItem()
                Dim di As New DirectoryInfo(s)
                item.Name = di.Name
                item.FullName = di.FullName
                item.CreationDate = di.CreationTime
                item.IsFolder = True
                list.Add(item)
            Next
            
            For Each s As String In files
                Dim item As New FileSystemItem()
                Dim fi As New FileInfo(s)
                item.Name = fi.Name
                item.FullName = fi.FullName
                item.CreationDate = fi.CreationTime
                item.IsFolder = True
                item.Size = fi.Length
                list.Add(item)
            Next
        
            If path.ToLower() <> strRootFolder.ToLower() Then
                Dim topitem As New FileSystemItem()
                Dim topdi As DirectoryInfo = New DirectoryInfo(path).Parent
                topitem.Name = "[Parent]"
                topitem.FullName = topdi.FullName
                list.Insert(0, topitem)
                Dim rootitem As New FileSystemItem()
                Dim rootdi As New DirectoryInfo(strRootFolder)
                rootitem.Name = "[Root]"
                rootitem.FullName = rootdi.FullName
                list.Insert(0, rootitem)
            End If
            
            Return list
            
        End Function
    
        Public Shared Sub CreateFolder(ByVal name As String, ByVal parentName As String)
            Dim di As New DirectoryInfo(parentName)
            di.CreateSubdirectory(name)
        End Sub
    
        Public Shared Sub DeleteFolder(ByVal path As String)
            Directory.Delete(path)
        End Sub
    
        Public Shared Sub MoveFolder(ByVal oldPath As String, ByVal newPath As String)
            Directory.Move(oldPath, newPath)
        End Sub
    
        Public Shared Sub CreateFile(ByVal filename As String, ByVal path As String)
            Dim fs As FileStream = File.Create(path & "\" & filename)
            fs.Close()
        End Sub
    
        Public Shared Sub CreateFile(ByVal filename As String, ByVal path As String, ByVal contents As Byte())
            Dim fs As FileStream = File.Create(path & "\" & filename)
            fs.Write(contents, 0, contents.Length)
            fs.Close()
        End Sub
    
        Public Shared Sub DeleteFile(ByVal path As String)
            File.Delete(path)
        End Sub
    
        Public Shared Sub MoveFile(ByVal oldPath As String, ByVal newPath As String)
            File.Move(oldPath, newPath)
        End Sub
    
        Public Shared Function GetItemInfo(ByVal path As String) As FileSystemItem
            
            Dim item As New FileSystemItem()
            
            If Directory.Exists(path) Then
                Dim di As New DirectoryInfo(path)
                item.Name = di.Name
                item.FullName = di.FullName
                item.CreationDate = di.CreationTime
                item.IsFolder = True
                item.LastAccessDate = di.LastAccessTime
                item.LastWriteDate = di.LastWriteTime
                item.FileCount = di.GetFiles().Length
                item.SubFolderCount = di.GetDirectories().Length
            Else
                Dim fi As New FileInfo(path)
                item.Name = fi.Name
                item.FullName = fi.FullName
                item.CreationDate = fi.CreationTime
                item.LastAccessDate = fi.LastAccessTime
                item.LastWriteDate = fi.LastWriteTime
                item.IsFolder = False
                item.Size = fi.Length
            End If
            
            Return item
            
        End Function
    
        Public Shared Sub CopyFolder(ByVal source As String, ByVal destination As String)
            
            Dim files As String()
            
            If destination(destination.Length - 1) <> System.IO.Path.DirectorySeparatorChar Then
                destination &= Path.DirectorySeparatorChar
            End If
            
            If Not Directory.Exists(destination) Then
                Directory.CreateDirectory(destination)
            End If
            
            files = Directory.GetFileSystemEntries(source)
            
            For Each element As String In files
                If Directory.Exists(element) Then
                    CopyFolder(element, destination & System.IO.Path.GetFileName(element))
                Else
                    File.Copy(element, destination & System.IO.Path.GetFileName(element), True)
                End If
            Next
            
        End Sub
        
    End Class
    
</script>

<script runat="server">

    <WebMethod()> _
    Public Shared Function GetItemInfo(ByVal path As String) As FileSystemItem
        Return FileSystemManager.GetItemInfo(path)
    End Function

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
        
        GridView1.Attributes.Add("oncontextmenu", "return FileManager.ShowContextMenu(event);")
        GridView1.Attributes.Add("onmouseover", "return FileManager.HideContextMenu();return FileManager.HideItemInfo();")
        GridView1.Attributes.Add("onmousemove", "return FileManager.HideItemInfo();")
    
        If Not IsPostBack Then BindGrid()
        
    End Sub
    
    Private Sub BindGrid()

        Dim list As List(Of FileSystemItem) = FileSystemManager.GetItems()
        GridView1.DataSource = list
        GridView1.DataBind()
        lblCurrentPath.Text = FileSystemManager.GetRootPath()
        
    End Sub

    Private Sub BindGrid(ByVal path As String)
        
        Dim list As List(Of FileSystemItem) = FileSystemManager.GetItems(path)
        
        GridView1.DataSource = list
        GridView1.DataBind()
        lblCurrentPath.Text = path
        
    End Sub

    Protected Sub btnDelete_Click(ByVal sender As Object, ByVal e As EventArgs)
    
        For Each row As GridViewRow In GridView1.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim cb As CheckBox = DirectCast(row.Cells(0).FindControl("CheckBox1"), CheckBox)
                If cb.Checked Then
                    Dim lb As LinkButton = DirectCast(row.Cells(1).FindControl("LinkButton1"), LinkButton)
                    If Directory.Exists(lb.CommandArgument) Then
                        FileSystemManager.DeleteFolder(lb.CommandArgument)
                    Else
                        FileSystemManager.DeleteFile(lb.CommandArgument)
                    End If
                End If
            End If
        Next
        
        BindGrid(lblCurrentPath.Text)
    
    End Sub

    Protected Sub GridView1_RowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)
        
        If e.Row.RowType = DataControlRowType.Header Then
            Dim cb As CheckBox = DirectCast(e.Row.Cells(0).FindControl("chkHeader"), CheckBox)
            cb.Attributes.Add("onclick", "FileManager.ToggleSelectionForAllItems(event);")
        End If
        
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim cb As CheckBox = DirectCast(e.Row.Cells(0).FindControl("CheckBox1"), CheckBox)
            cb.Attributes.Add("onclick", "FileManager.UnselectHeaderCheckBox(event);")
            Dim lb As LinkButton = DirectCast(e.Row.Cells(1).FindControl("LinkButton1"), LinkButton)
            If lb.Text <> "[Root]" AndAlso lb.Text <> "[Parent]" Then
                lb.Attributes.Add("onmousemove", "FileManager.BeginShowItemInfo(event);")
                lb.Attributes.Add("onmouseout", "FileManager.HideItemInfo();")
                lb.Attributes.Add("onmouseleave", "FileManager.BeginShowItemInfo(event);")
            Else
                e.Row.Cells(0).Controls.Clear()
            End If
        End If
    
    End Sub

    Protected Sub GridView1_RowCommand(ByVal sender As Object, ByVal e As GridViewCommandEventArgs)
        
        If Directory.Exists(e.CommandArgument.ToString()) Then
            BindGrid(e.CommandArgument.ToString())
        Else
            Dim path As String = e.CommandArgument.ToString()
            path = path.Replace(FileSystemManager.GetRootPath(), "~")
            path = path.Replace("\", "/")
            Response.Redirect(path)
        End If
        
    End Sub
    
    Protected Sub GridView1_RowCreated(ByVal sender As Object, ByVal e As GridViewRowEventArgs)

        Dim OnMouseOverStyle As String
        Dim OnMouseOutStyle As String

        If e.Row.RowType = DataControlRowType.DataRow Then
            If e.Row.RowState = DataControlRowState.Alternate Then
                OnMouseOverStyle = "this.style.backgroundColor='#99CC99'"
                OnMouseOutStyle = "this.style.backgroundColor='#99FF99'"
            Else
                OnMouseOverStyle = "this.style.backgroundColor='#99CC99'"
                OnMouseOutStyle = "this.style.backgroundColor='#FFFFFF'"
            End If
            e.Row.Attributes.Add("onmouseover", OnMouseOverStyle)
            e.Row.Attributes.Add("onmouseout", OnMouseOutStyle)
        End If

    End Sub

    Protected Sub btnCreate_Click(ByVal sender As Object, ByVal e As EventArgs)
        
        FileSystemManager.CreateFolder(TextBox2.Text, lblCurrentPath.Text)
        BindGrid(lblCurrentPath.Text)
        
    End Sub
    
    'To upload very large files, read this: http://support.microsoft.com/kb/295626

    Protected Sub btnPanel3Ok_Click(ByVal sender As Object, ByVal e As EventArgs)
        
        If FileUpload1.HasFile Then
            Dim path As String = lblCurrentPath.Text
            path &= System.IO.Path.GetFileName(FileUpload1.FileName)
            FileUpload1.PostedFile.SaveAs(path)
            BindGrid(lblCurrentPath.Text)
        End If
        
    End Sub

    Protected Sub btnUpload_Click(ByVal sender As Object, ByVal e As EventArgs)
        
        If FileUpload1.HasFile Then
            Dim path As String = lblCurrentPath.Text & "\"
            path &= System.IO.Path.GetFileName(FileUpload1.FileName)
            FileUpload1.PostedFile.SaveAs(path)
            BindGrid(lblCurrentPath.Text)
        End If
        
    End Sub

    Protected Sub btnCut_Click(ByVal sender As Object, ByVal e As EventArgs)
        
        Dim items As New List(Of String)()
        
        For Each row As GridViewRow In GridView1.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim cb As CheckBox = DirectCast(row.Cells(0).FindControl("CheckBox1"), CheckBox)
                If cb.Checked Then
                    Dim lb As LinkButton = DirectCast(row.Cells(1).FindControl("LinkButton1"), LinkButton)
                    items.Add(lb.CommandArgument)
                End If
            End If
        Next
        
        ViewState("clipboard") = items
        ViewState("action") = "cut"
        
    End Sub

    Protected Sub btnPaste_Click(ByVal sender As Object, ByVal e As EventArgs)
        
        If ViewState("clipboard") IsNot Nothing Then
            
            If ViewState("action").ToString() = "cut" Then
                
                Dim items As List(Of String) = DirectCast(ViewState("clipboard"), List(Of String))
                
                For Each s As String In items
                    If Directory.Exists(s) Then
                        Directory.Move(s, lblCurrentPath.Text & s.Substring(s.LastIndexOf("\")))
                    Else
                        File.Move(s, lblCurrentPath.Text & "\" & Path.GetFileName(s))
                    End If
                Next
                
            Else
                
                Dim items As List(Of String) = DirectCast(ViewState("clipboard"), List(Of String))
                
                For Each s As String In items
                    If Directory.Exists(s) Then
                        Dim di As New DirectoryInfo(s)
                        FileSystemManager.CopyFolder(s, lblCurrentPath.Text & "\" & di.Name)
                    Else
                        File.Copy(s, lblCurrentPath.Text & "\" & Path.GetFileName(s))
                    End If
                Next
                
            End If
            
        End If
        
        ViewState("clipboard") = Nothing
        ViewState("action") = Nothing
        BindGrid(lblCurrentPath.Text)
        
    End Sub

    Protected Sub btnCopy_Click(ByVal sender As Object, ByVal e As EventArgs)
        
        Dim items As New List(Of String)()
        
        For Each row As GridViewRow In GridView1.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim cb As CheckBox = DirectCast(row.Cells(0).FindControl("CheckBox1"), CheckBox)
                If cb.Checked Then
                    Dim lb As LinkButton = DirectCast(row.Cells(1).FindControl("LinkButton1"), LinkButton)
                    items.Add(lb.CommandArgument)
                End If
            End If
        Next
        
        ViewState("clipboard") = items
        ViewState("action") = "copy"
        
    End Sub

    Protected Sub btnRename_Click(ByVal sender As Object, ByVal e As EventArgs)
        
        Dim src As String = ""
        Dim dest As String = ""
        
        For Each row As GridViewRow In GridView1.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim cb As CheckBox = DirectCast(row.Cells(0).FindControl("CheckBox1"), CheckBox)
                If cb.Checked Then
                    Dim lb As LinkButton = DirectCast(row.Cells(1).FindControl("LinkButton1"), LinkButton)
                    src = lb.CommandArgument
                End If
            End If
        Next
        
        dest = src.Substring(0, src.LastIndexOf("\"c))
        dest = dest & "\" & TextBox3.Text
        
        If Directory.Exists(src) Then
            FileSystemManager.MoveFolder(src, dest)
        Else
            FileSystemManager.MoveFile(src, dest)
        End If
        
        BindGrid(lblCurrentPath.Text)
        
    End Sub

    Protected Sub CheckBox2_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)
        
        Dim cbHeader As CheckBox = DirectCast(sender, CheckBox)
        
        For Each row As GridViewRow In GridView1.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim cb As CheckBox = DirectCast(row.Cells(0).FindControl("CheckBox1"), CheckBox)
                cb.Checked = cbHeader.Checked
            End If
        Next
        
    End Sub

</script>

<html xmlns="http://www.w3.org/1999/xhtml" >

<head runat="server">
    
    <title>Web Site File Manager</title>
    
    <style type="text/css">
    
        body, div, span, p, td, th, input, select, button
        {
            font-family: Tahoma;
            font-size: 12px;
            color: #000000;
        }
        
        .DynamicPanel
        {
            border-right: darkgray 1px solid;
            border-top: darkgray 1px solid;
            border-left: darkgray 1px solid;
            border-bottom: darkgray 1px solid;
            background-color: #E0E0E0;   
            position: absolute;
            left: 0px;
            top: 0px;
            filter: alpha(opacity=90);
	        opacity: 0.9;
        }
        
        .modalBackground {
    	    background-color: Gray;
	        filter: alpha(opacity=70);
	        opacity: 0.7;
        }
        
    </style>
    
</head>
<body>
<form id="form1" runat="server">
<div>

<center>
    <strong><span style="color: #999900; font-size: 16px;">WEB SITE FILE MANAGER</span></strong>
</center>

<br />

<asp:ScriptManager ID="ScriptManager1" runat="server" EnablePageMethods="True" ScriptMode="Release" />

<script type="text/javascript">

Type.registerNamespace("BinaryIntellect.Web.UI");

BinaryIntellect.Web.UI.FileManager = function() 
{
    this._x;
    this._y;
}

BinaryIntellect.Web.UI.FileManager.prototype = 
{
    GetMouseX:function()
    {
        return this._x;
    },
    
    SetMouseX:function(value)
    {
        this._x=value;
    },
    
    GetMouseY:function()
    {
        return this._y;
    },
    
    SetMouseY:function(value)
    {
        this._y=value;
    },
   
    ShowContextMenu:function(evt)
    {
        var obj=document.getElementById('Panel5');
        obj.style.visibility="visible";
        obj.style.position="absolute";
        if(evt.x)
        {
            obj.style.posLeft=event.x;
            obj.style.posTop=event.y;
        }
        else
        {
            obj.style.left=evt.layerX + "px";
            obj.style.top=evt.layerY + "px";
        }
        return false;
    },
    
    HideContextMenu:function()
    {
        var obj=document.getElementById('Panel5');
        obj.style.visibility="hidden";
        return false;
    },
    
    ClickButton:function(srcElement)
    {
        FileManager.HideContextMenu();
        document.getElementById(srcElement).click();
        return false;
    },
    
    ToggleSelectionForAllItems:function(evt)
    {
        var count=0;
        var items=document.form1.getElementsByTagName("input");
        for(i=0;i<items.length;i++)
        {
            if(items[i].type=="checkbox")
            {
                if(evt.srcElement)
                {
                    if(items[i].id!=evt.srcElement.id)
                    {
                        items[i].checked=evt.srcElement.checked;
                        count++;
                    }
                }
                else
                {
                    if(items[i].id!=evt.target.id)
                    {
                        items[i].checked=evt.target.checked;
                        count++;
                    }
                }
            }
        }
    },
    
    UnselectHeaderCheckBox:function(evt)
    {
        if(evt.srcElement)
        {
            if(event.srcElement.checked==false)
            {
                var count=0;
                var items=document.form1.getElementsByTagName("input");
                for(i=0;i<items.length;i++)
                {
                    if(items[i].type=="checkbox")
                    {
                        if(items[i].id.indexOf('chkHeader')>0)
                        {
                            items[i].checked=false;
                        }
                    }
                }
            }
        }
        else
        {
            if(evt.target.checked==false)
            {
                var count=0;
                var items=document.form1.getElementsByTagName("input");
                for(i=0;i<items.length;i++)
                {
                    if(items[i].type=="checkbox")
                    {
                        if(items[i].id.indexOf('chkHeader')>0)
                        {
                            items[i].checked=false;
                        }
                    }
                }
            }
        }
    },
    
    BeginShowItemInfo:function(evt)
    {
        if(document.getElementById('chkSmartTips').checked)
        {
            if(evt.srcElement)
            {
                var path=document.getElementById('lblCurrentPath').innerText;
                path = path + "\\" + event.srcElement.innerText;
                FileManager.SetMouseX(event.x);
                FileManager.SetMouseY(event.y);
            }
            else
            {
                var path=document.getElementById('lblCurrentPath').textContent;
                path = path + "\\" + evt.target.textContent;
                FileManager.SetMouseX(evt.layerX);
                FileManager.SetMouseY(evt.layerY);
            }
            PageMethods.GetItemInfo(path,FileManager.EndShowItemInfo,FileManager.OnError);
        }
    },
    
    EndShowItemInfo:function(result)
    {
        var obj=document.getElementById('Panel6');
        obj.style.visibility="visible";
        obj.style.position="absolute";
        if(obj.style.posLeft)
        {
            obj.style.posLeft=FileManager.GetMouseX();
            obj.style.posTop=FileManager.GetMouseY();
        }
        else
        {
            obj.style.left=FileManager.GetMouseX() + "px";
            obj.style.top=FileManager.GetMouseY() + "px";
        }
        if(document.getElementById('lblFullName').innerText!=null)
        {
            document.getElementById('lblFullName').innerText=result.FullName;
            document.getElementById('lblCreatedOn').innerText=result.CreationDate;
            document.getElementById('lblLastAccess').innerText=result.LastAccessDate;
            document.getElementById('lblLastWrite').innerText=result.LastWriteDate;
            if(result.IsFolder)
            {
                document.getElementById('lblFileCount').innerText=result.FileCount;
            }
            else
            {
                document.getElementById('lblFileCount').innerText="-";
            }
            if(result.IsFolder)
            {
                document.getElementById('lblSubfolderCount').innerText=result.SubFolderCount;
            }
            else
            {
                document.getElementById('lblSubfolderCount').innerText="-";
            }
            if(result.IsFolder==false)
            {
                document.getElementById('lblSize').innerText=result.Size + " bytes";
            }
            else
            {
                document.getElementById('lblSize').innerText="-";
            }
        }
        else
        {
            document.getElementById('lblFullName').textContent=result.FullName;
            document.getElementById('lblCreatedOn').textContent=result.CreationDate;
            document.getElementById('lblLastAccess').textContent=result.LastAccessDate;
            document.getElementById('lblLastWrite').textContent=result.LastWriteDate;
            if(result.IsFolder)
            {
                document.getElementById('lblFileCount').textContent=result.FileCount;
            }
            else
            {
                document.getElementById('lblFileCount').textContent="-";
            }
            if(result.IsFolder)
            {
                document.getElementById('lblSubfolderCount').textContent=result.SubFolderCount;
            }
            else
            {
                document.getElementById('lblSubFolderCount').textContent="-";
            }
            if(result.IsFolder==false)
            {
                document.getElementById('lblSize').textContent=result.Size + " bytes";
            }
            else
            {
                document.getElementById('lblSize').textContent="-";
            }
            obj.style.overflow="auto";
        }
    },
    
    OnError:function(result)
    {
        if(result.get_exceptionType()=="System.IO.FileNotFoundException")
        {
            //do nothing    
        }
        else
        {
            alert(result.get_message());
        }
        
    },
    
    HideItemInfo:function()
    {
        var obj=document.getElementById('Panel6');
        obj.style.visibility="hidden";
        event.returnValue=false;
    },
    
    GetSelectedItemCount:function()
    {
        var count=0;
        var items=document.form1.getElementsByTagName("input");
        for(i=0;i<items.length;i++)
        {
            if(items[i].type=="checkbox")
            {
                if(items[i].checked)
                {
                    if(items[i].id!='chkSmartTips')
                    {
                        count++;
                    }
                }
            }
        }
        return count;
    },
    
    Rename:function()
    {
        if(document.getElementById('TextBox3').value=="")
        {
            alert("Please enter new name!");
            return false;
        }
        var count=0;
        count=FileManager.GetSelectedItemCount();
        if(count==0)
        {
            alert("Please select an item to rename");
            return false;
        }
        if(count>1)
        {
            alert("Please select only one item to rename");
            return false;
        }
        else
        {
            __doPostBack('btnRename','');
        }
    },
    
    Cut:function()
    {
        var count=0;
        var items=document.form1.getElementsByTagName("input");
        count=FileManager.GetSelectedItemCount();
        if(count==0)
        {
            alert("Please select an item to cut");
            return false;
        }
        else
        {
            __doPostBack('btnRename','');
        }
    },
    
    Paste:function()
    {
        __doPostBack('btnPaste','');
    },
    
    Copy:function()
    {
        var count=0;
        var items=document.form1.getElementsByTagName("input");
        count=FileManager.GetSelectedItemCount();
        if(count==0)
        {
            alert("Please select an item to copy");
            return false;
        }
        else
        {
            __doPostBack('btnCopy','');
        }
    },
    
    Create:function()
    {
        if(document.getElementById('TextBox2').value=="")
        {
            alert("Please enter folder name!");
            return false;
        }
        else
        {
            __doPostBack('btnCreate','');
        }
    },
    
    Delete:function()
    {
        var count=0;
        var items=document.form1.getElementsByTagName("input");
        count=FileManager.GetSelectedItemCount();
        if(count==0)
        {
            alert("Please select items to delete");
            return false;
        }
        else
        {
            __doPostBack('btnDelete','')
        }
    },
    
    Upload:function()
    {
        if(document.getElementById('FileUpload1').value=="")
        {
            alert("Please select file to upload!");
            return false;
        }
        else
        {
            __doPostBack('btnUpload','');
        }
    }
}

BinaryIntellect.Web.UI.FileManager.registerClass('BinaryIntellect.Web.UI.FileManager', null, Sys.IDisposable);

</script>

    </div>
    
        <asp:UpdatePanel ID="UpdatePanel1" runat="server">
            <ContentTemplate>
                
                <table style="width: 100%">
                    <tr>
                        <td align="left">
                            <asp:Button ID="btnCreate" runat="server" Text="Create" Width="75px" OnClick="btnCreate_Click" ToolTip="Create a new folder" />
                            <asp:Button ID="btnCut" runat="server" Text="Cut" Width="75px" OnClick="btnCut_Click" OnClientClick="return FileManager.Cut();" ToolTip="Cut selected items" />
                            <asp:Button ID="btnCopy" runat="server" Text="Copy" Width="75px" OnClick="btnCopy_Click" OnClientClick="return FileManager.Copy();" ToolTip="Copy selected items"  />
                            <asp:Button ID="btnPaste" runat="server" Text="Paste" Width="75px" OnClick="btnPaste_Click" ToolTip="Paste selected items inside current folder"  />
                            <asp:Button ID="btnRename" runat="server" Text="Rename" Width="75px" OnClick="btnRename_Click" ToolTip="Rename selected item" />
                            <asp:Button ID="btnDelete" runat="server" Text="Delete" Width="75px" OnClick="btnDelete_Click" ToolTip="Delete selected items" />
                            <cc1:modalpopupextender id="ModalPopupExtender1" runat="server" TargetControlID="btnDelete" PopupControlID="Panel1" OkControlID="btnYes" CancelControlID="btnNo" OnOkScript="FileManager.Delete();" BackgroundCssClass="modalBackground"></cc1:modalpopupextender>
                            <cc1:modalpopupextender id="Modalpopupextender2" runat="server" TargetControlID="btnCreate" PopupControlID="Panel2" OkControlID="btnPanel2Yes" CancelControlID="btnPanel2No" OnOkScript="FileManager.Create();" BackgroundCssClass="modalBackground"></cc1:modalpopupextender>
                            <cc1:modalpopupextender id="Modalpopupextender4" runat="server" TargetControlID="btnRename" PopupControlID="Panel4" OkControlID="btnPanel4Ok" CancelControlID="btnPanel4Cancel" OnOkScript="FileManager.Rename();" BackgroundCssClass="modalBackground"></cc1:modalpopupextender>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <asp:Label ID="Label4" runat="server" Font-Bold="True" Text="Current Path:"></asp:Label>
                            <asp:Label ID="lblCurrentPath" runat="server"></asp:Label>
                        </td>
                    </tr>
                    <tr>
                        <td>
                        
                            <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" CellPadding="5" ForeColor="#333333" GridLines="Vertical" Width="100%" OnRowCommand="GridView1_RowCommand" OnRowDataBound="GridView1_RowDataBound" OnRowCreated="GridView1_RowCreated">
                                
                                <Columns>
                                
                                    <asp:TemplateField>
                                        <ItemTemplate>
                                            <asp:CheckBox ID="CheckBox1" runat="server" />
                                        </ItemTemplate>
                                        <HeaderTemplate>
                                            <asp:CheckBox ID="chkHeader" runat="server" OnCheckedChanged="CheckBox2_CheckedChanged" />
                                        </HeaderTemplate>
                                        <ItemStyle Width="1%" Wrap="False" />
                                    </asp:TemplateField>
                                    
                                    <asp:TemplateField HeaderText="Name" ItemStyle-HorizontalAlign="Left" HeaderStyle-HorizontalAlign="Left">
                                        <EditItemTemplate>
                                            <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("Name") %>'></asp:TextBox>
                                        </EditItemTemplate>
                                        <ItemTemplate>
                                            <asp:LinkButton ID="LinkButton1" runat="server" CommandArgument='<%# Eval("FullName") %>' Text='<%# Eval("Name") %>'></asp:LinkButton>
                                        </ItemTemplate>
                                    </asp:TemplateField>
                                    
                                    <asp:BoundField DataField="CreationDate" HeaderText="Created On" HeaderStyle-HorizontalAlign="Left">
                                        <ItemStyle Width="5%" Wrap="False" HorizontalAlign="Left" />
                                    </asp:BoundField>
                                    
                                    <asp:TemplateField HeaderText="Size" ItemStyle-HorizontalAlign="Left" HeaderStyle-HorizontalAlign="Left" ItemStyle-Wrap="false" ItemStyle-Width="5%">
                                        <ItemTemplate>
                                            <asp:Label ID="lblSizeInKB" runat="server"><%# Format(Eval("Size")/1024, "#0.00") & " KB" %></asp:Label>
                                        </ItemTemplate>
                                    </asp:TemplateField>
                 
                                </Columns>
                                
                                <RowStyle BackColor="#FFFFFF" ForeColor="#333333" />
                                <EditRowStyle BackColor="#999999" />
                                <SelectedRowStyle BackColor="#FFFACD" Font-Bold="True" ForeColor="#333333" />
                                <PagerStyle BackColor="#284775" ForeColor="White" HorizontalAlign="Center" />
                                <HeaderStyle BackColor="#999900" Font-Bold="True" ForeColor="White" />
                                <AlternatingRowStyle BackColor="#99FF99" ForeColor="#284775" />
                                <FooterStyle BackColor="#CCCCCC" Font-Bold="True" ForeColor="White" />
                                
                            </asp:GridView>
                
                        </td>
                    </tr>
                    <tr>
                        <td align="left">
                            <asp:Button ID="Button1" runat="server" Text="Create" Width="75px" OnClick="btnCreate_Click" OnClientClick="return FileManager.ClickButton('btnCreate');" ToolTip="Create a new folder" />
                            <asp:Button ID="Button2" runat="server" Text="Cut" Width="75px" OnClick="btnCut_Click" OnClientClick="return FileManager.ClickButton('btnCut');" ToolTip="Cut selected items" />
                            <asp:Button ID="Button3" runat="server" Text="Copy" Width="75px" OnClick="btnCopy_Click" OnClientClick="return FileManager.ClickButton('btnCopy');" ToolTip="Copy selected items"  />
                            <asp:Button ID="Button4" runat="server" Text="Paste" Width="75px" OnClick="btnPaste_Click" OnClientClick="return FileManager.ClickButton('btnPaste');" ToolTip="Paste selected items"  />
                            <asp:Button ID="Button5" runat="server" Text="Rename" Width="75px" OnClick="btnRename_Click" OnClientClick="return FileManager.ClickButton('btnRename');" ToolTip="Rename selected item" />
                            <asp:Button ID="Button6" runat="server" Text="Delete" Width="75px" OnClick="btnDelete_Click" OnClientClick="return FileManager.ClickButton('btnDelete');" ToolTip="Delete selected items" />
                        </td>
                    </tr>
                </table>
                
                &nbsp;
                
            </ContentTemplate>
        </asp:UpdatePanel>
        
        <asp:LinkButton ID="btnUpload" runat="server" OnClick="btnUpload_Click">Upload a file to this folder</asp:LinkButton>
        <cc1:modalpopupextender id="Modalpopupextender3" runat="server" TargetControlID="btnUpload" PopupControlID="Panel3" OkControlID="btnPanel3Ok" CancelControlID="btnPanel3Cancel" OnOkScript="FileManager.Upload();" BackgroundCssClass="modalBackground"></cc1:modalpopupextender>
        <br />
        
        <asp:UpdateProgress ID="UpdateProgress1" runat="server" AssociatedUpdatePanelID="UpdatePanel1">
            <ProgressTemplate>
                <asp:Label ID="Label1" runat="server" ForeColor="Red" Text="Please Wait..."></asp:Label>
            </ProgressTemplate>
        </asp:UpdateProgress>
        
        <asp:Panel ID="Panel1" runat="server" CssClass="DynamicPanel">
            <table border="1"><tr><td>
            <table cellpadding="10">
                <tr>
                    <td align="center">
                        <asp:Label ID="Label2" runat="server" Text="All the contents of the selected file or folder will be deleted. Do you wish to continue?"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td align="center">
                        <asp:Button ID="btnYes" runat="server" Text="Yes" Width="75px" />
                        <asp:Button ID="btnNo" runat="server" Text="No" Width="75px" />
                    </td>
                </tr>
            </table>
            </td></tr></table>
        </asp:Panel>
        
        <asp:Panel ID="Panel2" runat="server" CssClass="DynamicPanel">
            <table border="1"><tr><td>
            <table cellpadding="10">
                <tr>
                    <td align="center">
                        <asp:Label ID="Label3" runat="server" Font-Bold="True" Text="Enter the folder name to create:"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td align="center">
                        <asp:TextBox ID="TextBox2" runat="server" Width="300"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td align="center">
                        &nbsp;<asp:Button ID="btnPanel2Yes" runat="server" Text="OK" Width="75px" />
                        <asp:Button ID="btnPanel2No" runat="server" Text="Cancel" Width="75px" />
                    </td>
                </tr>
            </table>
            </td></tr></table>
        </asp:Panel>
        
        <asp:Panel ID="Panel3" runat="server" CssClass="DynamicPanel">
            <table border="1"><tr><td>
            <table cellpadding="10">
                <tr>
                    <td align="center">
                        <asp:Label ID="Label6" runat="server" Font-Bold="True" Text="Select file to be uploaded:"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td align="center">
                        <asp:FileUpload ID="FileUpload1" runat="server" Width="300" />
                    </td>
                </tr>
                <tr>
                    <td align="center">
                        &nbsp;<asp:Button ID="btnPanel3Ok" runat="server" Text="OK" Width="75px" />
                        <asp:Button ID="btnPanel3Cancel" runat="server" Text="Cancel" Width="75px" />
                    </td>
                </tr>
            </table>
            </td></tr></table>
        </asp:Panel>
        
        <asp:Panel ID="Panel4" runat="server" CssClass="DynamicPanel">
            <table border="1"><tr><td>
            <table cellpadding="10">
                <tr>
                    <td align="center">
                        <asp:Label ID="Label5" runat="server" Font-Bold="True" Text="Enter new name for the selected item:"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td align="center">
                        <asp:TextBox ID="TextBox3" runat="server" Width="300"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td align="center">
                        &nbsp;<asp:Button ID="btnPanel4Ok" runat="server" Text="OK" Width="75px" />
                        <asp:Button ID="btnPanel4Cancel" runat="server" Text="Cancel" Width="75px" />
                    </td>
                </tr>
            </table>
            </td></tr></table>
        </asp:Panel>
        
        <asp:Panel ID="Panel5" runat="server" CssClass="DynamicPanel" Width="150px">
            <table style="width: 100%">
                <tr>
                    <td align="left">
                        <asp:LinkButton ID="LinkButton2" runat="server" OnClientClick="return FileManager.ClickButton('btnCreate');">Create</asp:LinkButton>
                    </td>
                </tr>
                <tr>
                    <td align="left">
                        <hr />
                    </td>
                </tr>
                <tr>
                    <td align="left">
                        <asp:LinkButton ID="LinkButton3" runat="server" OnClientClick="return FileManager.ClickButton('btnCut');">Cut</asp:LinkButton>
                    </td>
                </tr>
                <tr>
                    <td align="left">
                        <asp:LinkButton ID="LinkButton4" runat="server" OnClientClick="return FileManager.ClickButton('btnCopy');">Copy</asp:LinkButton>
                    </td>
                </tr>
                <tr>
                    <td align="left">
                        <asp:LinkButton ID="LinkButton5" runat="server" OnClientClick="return FileManager.ClickButton('btnPaste');">Paste</asp:LinkButton>
                    </td>
                </tr>
                <tr>
                    <td align="left">
                        <hr />
                    </td>
                </tr>
                <tr>
                    <td align="left">
                        <asp:LinkButton ID="LinkButton6" runat="server" OnClientClick="return FileManager.ClickButton('btnRename');">Rename</asp:LinkButton>
                    </td>
                </tr>
                <tr>
                    <td align="left" style="height: 21px">
                        <asp:LinkButton ID="LinkButton7" runat="server" OnClientClick="return FileManager.ClickButton('btnDelete');">Delete</asp:LinkButton>
                    </td>
                </tr>
                <tr>
                    <td align="left" style="height: 21px">
                        <hr />
                    </td>
                </tr>
                <tr>
                    <td align="left" style="height: 21px">
                        <asp:LinkButton ID="LinkButton8" runat="server" OnClientClick="return FileManager.ClickButton('btnUpload');">Upload File</asp:LinkButton>
                    </td>
                </tr>
                <tr>
                    <td align="left" style="height: 21px">
                        <hr />
                    </td>
                </tr>
                <tr>
                    <td align="left" style="height: 21px">
                        <asp:CheckBox ID="chkSmartTips" runat="server" Font-Bold="True" Text="Show Smart Tips" Checked="True" />
                    </td>
                </tr>
            </table>
        </asp:Panel>
        
        &nbsp;
        <cc1:TextBoxWatermarkExtender ID="TextBoxWatermarkExtender2" runat="server" TargetControlID="TextBox3" WatermarkText="Enter new name for the selected item" />
        &nbsp;
        <cc1:TextBoxWatermarkExtender ID="TextBoxWatermarkExtender1" runat="server" TargetControlID="TextBox2" WatermarkText="Enter folder name to create" />
        &nbsp;
        &nbsp;
        &nbsp;
        &nbsp;
        <cc1:modalpopupextender id="Modalpopupextender5" runat="server" TargetControlID="LinkButton8" PopupControlID="Panel3" OkControlID="btnPanel3Ok" CancelControlID="btnPanel3Cancel" OnOkScript="FileManager.Upload();" />
        
        <asp:Panel ID="Panel6" runat="server" CssClass="DynamicPanel" width="500px">
            <table id="tblInfo" style="width: 100%">
                <tr>
                    <td style="overflow: visible; width: 150px" align="right" nowrap>
                        <asp:Label ID="Label7" runat="server" Text="Full Name :" Font-Bold="True"></asp:Label>
                    </td>
                    <td nowrap>
                        <asp:Label ID="lblFullName" runat="server" Font-Bold="True"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td style="overflow: visible; width: 150px" align="right" nowrap>
                        <asp:Label ID="Label8" runat="server" Text="Created On :" Font-Bold="True"></asp:Label>
                    </td>
                    <td nowrap>
                        <asp:Label ID="lblCreatedOn" runat="server" Font-Bold="True"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td style="overflow: visible; width: 150px" align="right" nowrap>
                        <asp:Label ID="Label9" runat="server" Text="Last Accessed On :" Font-Bold="True"></asp:Label>
                    </td>
                    <td nowrap>
                        <asp:Label ID="lblLastAccess" runat="server" Font-Bold="True"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td style="overflow: visible; width: 150px" align="right" nowrap>
                        <asp:Label ID="Label10" runat="server" Text="Last Modified On :" Font-Bold="True"></asp:Label>
                    </td>
                    <td nowrap>
                        <asp:Label ID="lblLastWrite" runat="server" Font-Bold="True"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td style="overflow: visible; width: 150px" align="right" nowrap>
                        <asp:Label ID="Label11" runat="server" Text="File Count :" Font-Bold="True"></asp:Label>
                    </td>
                    <td nowrap>
                        <asp:Label ID="lblFileCount" runat="server" Font-Bold="True"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td style="overflow: visible; width: 150px" align="right" nowrap>
                        <asp:Label ID="Label12" runat="server" Text="Subfolder Count :" Font-Bold="True"></asp:Label>
                    </td>
                    <td nowrap>
                        <asp:Label ID="lblSubFolderCount" runat="server" Font-Bold="True"></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td style="overflow: visible; width: 150px" align="right" nowrap>
                        <asp:Label ID="Label13" runat="server" Text="Size :" Font-Bold="True"></asp:Label>
                    </td>
                    <td nowrap>
                        <asp:Label ID="lblSize" runat="server" Font-Bold="True"></asp:Label>
                    </td>
                </tr>
            </table>
        </asp:Panel>
        
        <center>
            <br /><br />
            Copyright &copy; - All Rights Reserved.
            <br />Original C# Version By: <a href="http://www.binaryintellect.net" target="_blank">BinaryIntellect Consulting</a>
            <br />VB.NET Version By: <a href="http://www.basgun.com" target="_blank">Mustafa Basgun</a>
            <br />Last Updated on 12/05/2007
        </center>
        
</form>
</body>
</html>
